OSDN Git Service

Add Patrick Marlier to ChangeLog entry.
[pf3gnuchains/gcc-fork.git] / contrib / gcc_update
1 #! /bin/sh
2 #
3 # Update a local Subversion, Git or Mercurial tree from the GCC
4 # repository, with an emphasis on treating generated files correctly, so
5 # that autoconf, gperf et al are not required for the ``end'' user.
6 #
7 # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009, 2010,
8 # 2011 Free Software Foundation
9 # Originally by Gerald Pfeifer <pfeifer@dbai.tuwien.ac.at>, August 1998.
10 #
11 # This script is Free Software, and it can be copied, distributed and
12 # modified as defined in the GNU General Public License.  A copy of
13 # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
14 #
15 #
16 # By default all command-line options are passed to `svn update` or `hg/git
17 # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18 # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
19 # are omitted.
20 #
21 # If the first parameter reads --patch, the second parameter is considered
22 # a patch file.
23 #
24 # If the first parameter is --touch, no svn operation will be performed,
25 # only generated files that appear to be out of date in the local tree
26 # will be touched.
27 #
28 # If the first parameter is --list, a list of the generated files and
29 # their dependencies will be printed; --help prints this message.
30 #
31 # If the first parameter is --silent, this script prints nothing other
32 # than error messages; the second parameter is then interpreted as above.
33 #
34 # Examples:
35 #
36 # contrib/gcc_update -r 8712
37 # contrib/gcc_update --patch some-patch
38 # contrib/gcc_update --touch
39 # contrib/gcc_update --list
40
41
42 # Default options used when updating (none).
43 UPDATE_OPTIONS=""
44
45 # Set the locale to C to make this script work for users with foreign
46 # locale like e.g. French UTF-8.
47 LANG=C
48 LC_ALL=C
49 export LANG LC_ALL
50
51 ######## Anything below shouldn't be changed by regular users.
52
53 # Arrange for the value of $0 to be available for functions
54 self=$0
55
56 # This function prints its arguments to standard output unless
57 # "silent" is set.
58 unset silent
59 chat () {
60     if [ -z "$silent" ]; then
61         echo "$@"
62     fi
63 }
64
65 # This function prints a list of all generated files, along with their
66 # dependencies.  Note that only one target is supported per line: the
67 # colon is stripped from the output.
68 files_and_dependencies () {
69     sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
70 # fixincludes
71 fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
72 fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
73 # intl library
74 intl/plural.c: intl/plural.y
75 intl/configure: intl/configure.ac intl/aclocal.m4
76 intl/config.h.in: intl/configure.ac intl/aclocal.m4
77 # Now, proceed to gcc automatically generated files
78 gcc/configure: gcc/configure.ac
79 gcc/cstamp-h.in: gcc/configure.ac
80 gcc/config.in: gcc/cstamp-h.in
81 gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
82 gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cores.def gcc/config/arm/gentune.sh
83 gcc/config/arm/arm-tables.opt: gcc/config/arm/arm-arches.def gcc/config/arm/arm-cores.def gcc/config/arm/arm-fpus.def gcc/config/arm/genopt.sh
84 gcc/config/avr/avr-tables.opt: gcc/config/avr/avr-mcus.def gcc/config/avr/genopt.sh
85 gcc/config/avr/t-multilib: gcc/config/avr/avr-mcus.def gcc/config/avr/genmultilib.awk
86 gcc/config/avr/multilib.h: gcc/config/avr/avr-mcus.def gcc/config/avr/genmultilib.awk
87 gcc/config/c6x/c6x-tables.opt: gcc/config/c6x/c6x-isas.def gcc/config/c6x/genopt.sh
88 gcc/config/c6x/c6x-sched.md: gcc/config/c6x/c6x-sched.md.in gcc/config/c6x/gensched.sh
89 gcc/config/c6x/c6x-mult.md: gcc/config/c6x/c6x-mult.md.in gcc/config/c6x/genmult.sh
90 gcc/config/m68k/m68k-tables.opt: gcc/config/m68k/m68k-devices.def gcc/config/m68k/m68k-isas.def gcc/config/m68k/m68k-microarchs.def gcc/config/m68k/genopt.sh
91 gcc/config/mips/mips-tables.opt: gcc/config/mips/mips-cpus.def gcc/config/mips/genopt.sh
92 gcc/config/rs6000/rs6000-tables.opt: gcc/config/rs6000/rs6000-cpus.def gcc/config/rs6000/genopt.sh
93 # And then, language-specific files
94 gcc/cp/cfns.h: gcc/cp/cfns.gperf
95 gcc/java/keyword.h: gcc/java/keyword.gperf
96 # testsuite
97 # Without this, _Pragma3.c can have a false negative.
98 gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
99 # Similarly, without this, you will see:
100 # direct2s.c:35: warning: current file is older than direct2.c
101 gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
102 # lto-plugin
103 lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
104 lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
105 # And libraries, at last
106 libbanshee/configure: libbanshee/configure.ac
107 libmudflap/configure: libmudflap/configure.ac
108 libobjc/configure: libobjc/configure.ac
109 zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
110 zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
111 zlib/configure: zlib/configure.ac zlib/aclocal.m4
112 fastjar/aclocal.m4: fastjar/configure.ac
113 fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
114 fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
115 boehm-gc/aclocal.m4: boehm-gc/configure.ac
116 boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
117 boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
118 libada/configure: libada/configure.ac
119 libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
120 libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
121 libffi/configure: libffi/configure.ac libffi/aclocal.m4
122 libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
123 libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
124 libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
125 libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
126 libjava/aclocal.m4: libjava/configure.ac
127 libjava/Makefile.in: libjava/Makefile.am libjava/configure.ac libjava/aclocal.m4
128 libjava/configure: libjava/configure.ac libjava/aclocal.m4
129 libjava/libltdl/aclocal.m4: libjava/libltdl/configure.ac libjava/libltdl/acinclude.m4
130 libjava/libltdl/Makefile.in: libjava/libltdl/Makefile.am libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
131 libjava/libltdl/configure: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
132 libjava/libltdl/config-h.in: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
133 libcpp/aclocal.m4: libcpp/configure.ac
134 libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
135 libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
136 libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
137 libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
138 libgomp/testsuite/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
139 libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
140 libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
141 libitm/aclocal.m4: libitm/configure.ac libitm/acinclude.m4
142 libitm/Makefile.in: libitm/Makefile.am libitm/aclocal.m4
143 libitm/testsuite/Makefile.in: libitm/testsuite/Makefile.am libitm/aclocal.m4
144 libitm/configure: libitm/configure.ac libitm/aclocal.m4
145 libitm/config.h.in: libitm/configure.ac libitm/aclocal.m4
146 # Top level
147 Makefile.in: Makefile.tpl Makefile.def
148 configure: configure.ac config/acx.m4
149 EOF
150 }
151
152
153 # This function touches generated files such that the ``end'' user does
154 # not have to rebuild them.
155 touch_files () {
156     rm -f Makefile.$$
157     echo 'all: \' > Makefile.$$
158     files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
159     echo '; @true' >> Makefile.$$
160     files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
161     files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
162     echo ':' >> Makefile.$$
163     echo '      @for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
164     echo '      echo Touching $@...; \' >> Makefile.$$
165     chat '      echo Touching $@... 1>&2; \' >> Makefile.$$
166     echo '      touch $@' >> Makefile.$$
167     files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
168
169     # We would have to explicitly shut off the "Entering... Leaving..."
170     # messages through "--no-print-directory" to handle the case when
171     # we were called from a recursive invocation (i.e. "$(MAKE)" in a
172     # Makefile, not just make).  Passing only "-s" doesn't help then,
173     # because make has helpfully added "-w" to MAKEFLAGS automatically.
174     # Unfortunately we do not require GNU make other than for building
175     # and testing, so let's just grep known text explicitly echoed by
176     # the rule.
177     while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
178       sleep 1
179     done 2>&1
180     rm -f Makefile.$$
181 }
182
183
184 # Whenever we update the tree or install a patch, we may be modifying
185 # this script.  By re-execing it, we ensure that the appropriate
186 # dependencies and rules will be used.
187 touch_files_reexec () {
188     chat "Adjusting file timestamps"
189     exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
190 }
191
192 # This functions applies a patch to an existing tree.
193 apply_patch () {
194     if [ -f "$1" ]; then
195         echo "Applying patch file $1"
196         case $1 in
197         *gz)
198             gzip -d -c "$1" | patch -p1 ;;
199         *bz2)
200             bzip2 -d -c "$1" | patch -p1 ;;
201         *)
202             patch -p1 < "$1";;
203         esac
204     fi
205     touch_files_reexec
206 }
207
208 # Check whether this indeed looks like a local tree.
209 if [ ! -f gcc/version.c ]; then
210     echo "This does not seem to be a GCC tree!"
211     exit
212 fi
213
214 case "$1" in
215 --silent)
216     silent=t
217     shift
218     ;;
219 esac
220
221 case "$1" in
222 # First of all, check whether we are going to process a patch.
223 --patch)
224     if test "$#" != 2; then
225         echo "$1" expects only one argument >&2
226         exit 1
227     fi
228     apply_patch "${2}"
229     exit $?
230     ;;
231
232 --touch)
233     if test "$#" != 1; then
234         echo "$1" does not expect any argument >&2
235         exit 1
236     fi
237     touch_files
238     exit $?
239     ;;
240
241 --list)
242     if test "$#" != 1; then
243         echo "$1" does not expect any argument >&2
244         exit 1
245     fi
246     files_and_dependencies | sed 's/ /: /'
247     exit $?
248     ;;
249
250 --help)
251     sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
252 \
253
254 p
255 }' \
256         -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
257     exit $?
258     ;;
259
260 esac
261
262 # Check for known version control systems.
263 if [ -d .git ]; then
264     GCC_GIT=${GCC_GIT-${GIT-git}}
265     vcs_type="git"
266 elif [ -d .hg ]; then
267     GCC_HG=${GCC_HG-${HG-hg}}
268     vcs_type="hg"
269 elif [ -d .svn ]; then
270     GCC_SVN=${GCC_SVN-${SVN-svn}}
271     vcs_type="svn"
272 else
273     echo "This does not seem to be a GCC GIT/HG/SVN tree!"
274     exit
275 fi
276
277 # Check command-line options
278 if [ x"${1}"x = x"--nostdflags"x ]; then
279     shift
280 else
281     set -- $UPDATE_OPTIONS ${1+"$@"}
282 fi
283
284 case $vcs_type in
285     git)
286         chat "Updating GIT tree"
287
288         $GCC_GIT diff --quiet --exit-code HEAD
289         if [ $? -ne 0 ]; then
290             echo "Attempting to update a dirty git tree!" >&2
291             echo "Commit or stash your changes first and retry." >&2
292             exit 1
293         fi
294
295         $GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
296         if [ $? -ne 0 ]; then
297             (touch_files_reexec)
298             echo "git pull of full tree failed." >&2
299             exit 1
300         fi
301
302         revision=`$GCC_GIT log -n1 --pretty=%p:%t:%H`
303         branch=`$GCC_GIT name-rev --name-only HEAD || :`
304         ;;    
305
306     hg)
307         chat "Updating HG tree"
308
309         # Add -q so untracked files aren't listed.
310         if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
311             echo "Attempting to update a dirty hg tree!" >&2
312             echo "Commit or revert your changes first and retry." >&2
313             exit 1
314         fi
315
316         # Check for mq extension.  mq patches must be popped so tip has
317         # been converted from the SVN tree.
318         if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
319             # FIXME: Perhaps pop queue instead?  We could do that since we
320             # know the tree is clean.
321             echo "Attempting to update hg tree with mq patches applied!" >&2
322             echo "Pop your patches first and retry." >&2
323             exit 1
324         fi
325
326         # Update tree, but make sure to only pull the default branch.
327         # Otherwise all branches in the upstream repo are added, even if
328         # only a single one has been cloned.
329         $GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
330         if [ $? -ne 0 ]; then
331             (touch_files_reexec)
332             echo "hg pull of full tree failed." >&2
333             exit 1
334         fi
335
336         # Update tree.  Needs to be done separately from pull so
337         # gcc_update -rREV works.
338         $GCC_HG update ${silent+-q} ${1+"$@"}
339         if [ $? -ne 0 ]; then
340             (touch_files_reexec)
341             echo "hg update of full tree failed." >&2
342             exit 1
343         fi
344
345         # Extract SVN revision corresponding to parents, as stored by
346         # hg convert.  Before hg 1.4.3, there's no template keyword
347         # corresponding to the extra: tag, so need to use hg log --debug
348         # to extract the info.
349         parents=`$GCC_HG parents --template '{rev}'`
350         convert_revision=`$GCC_HG log --debug -r$parents | \
351             sed -ne "/^extra:.*convert_revision=svn:/ {
352                 s%^[^/]*/%%
353                 p
354             }"`
355         revision=`echo $convert_revision | sed -e 's/.*@//'`
356         branch=`echo $convert_revision | sed -e 's%branches/%%' -e 's/@.*//'`
357         ;;
358
359     svn)
360         chat "Updating SVN tree"
361
362         $GCC_SVN ${silent+-q}  --non-interactive update ${1+"$@"}
363         if [ $? -ne 0 ]; then
364             (touch_files_reexec)
365             echo "SVN update of full tree failed." >&2
366             exit 1
367         fi
368
369         revision=`svn info | awk '/Revision:/ { print $2 }'`
370         branch=`svn info | sed -ne "/URL:/ {
371             s,.*/trunk,trunk,
372             s,.*/branches/,,
373             s,.*/tags/,,
374             p
375         }"`
376         ;;
377 esac
378
379 rm -f LAST_UPDATED gcc/REVISION
380 {
381     date
382     echo "`TZ=UTC date` (revision $revision)"
383 } > LAST_UPDATED
384 echo "[$branch revision $revision]" > gcc/REVISION
385
386 touch_files_reexec